EDIT - bug #6067

CdmEagerLoadingException after having multiple editors open for ~4 hours
09/12/2016 09:23 AM - Andreas Kohlbecker

Status: New Start date:

Priority: New Due date:

Assignee: Katja Luther % Done: 0%
Category: taxeditor Estimated time: 0:00 hour

Target version: Unassigned CDM tickets

Severity: normal Found in Version:
at org.eclipse.ui.forms.ManagedForm.setInput (ManagedForm. java:238)
at eu.etaxonomy.taxeditor.view.AbstractCdmDataViewer.refresh (AbstractCdmDataViewer
Caused by: java.lang.NullPointerException

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmGenericDaoImpl.initializeC
ollection (CdmGenericDaoImpl. java:785)

at eu.etaxonomy.cdm.api.service.CommonServiceImpl.initializeCollection (CommonServi
ceImpl.java:342)

at sun.reflect.GeneratedMethodAccessorl581.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja
va:43)

at java.lang.reflect.Method.invoke (Method. java:497)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtil
s.java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (Re
flectiveMethodInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:157)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (Trans
actionInterceptor.java:110)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.

java:208)

at com.sun.proxy.SProxy3375.initializeCollection (Unknown Source)

at sun.reflect.GeneratedMethodAccessorl581.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja
va:43)

at java.lang.reflect.Method.invoke (Method.java:497)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtil
s.java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (Re
flectiveMethodInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:157)

at org.springframework.remoting.support.RemoteInvocationTracelnterceptor.invoke (Re
moteInvocationTracelnterceptor.java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.

java:208)

at com.sun.proxy.S$SProxy3634.initializeCollection (Unknown Source)

at sun.reflect.GeneratedMethodAccessor2414.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja
va:43)

at java.lang.reflect.Method.invoke (Method. java:497)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemoteInvocation.j
ava:212)

at org.springframework.remoting.support.DefaultRemoteInvocationExecutor.invoke (Def
aultRemoteInvocationExecutor. java:39)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (Remot
eInvocationBasedExporter. java:78)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCre
ateResult (RemoteInvocationBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleReque
st (HttpInvokerServiceExporter. java:74)
at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpReques
tHandlerAdapter. java:51)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet.
java:959)

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet.j
ava:893)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlie
t.Jjava:969)

at org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet. java:8

71)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:707)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet. java:
845)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder.java:808)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. ja
va:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.inv
oke (FilterSecurityInterceptor. java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doF
ilter (FilterSecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy. java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (Exc
eptionTranslationFilter. java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (Sessi
onManagementFilter.java:122)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy. java:330)

at org.springframework.security.web.authentication.AnonymousAuthenticationFilter.d
oFilter (AnonymousAuthenticationFilter.java:111)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFi
lter.doFilter (SecurityContextHolderAwareRequestFilter.java:169)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy. java:330)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (
RequestCacheAwareFilter. java:48)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.d
oFilterInternal (BasicAuthenticationFilter. java:213)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilt
er.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.authentication.ui.DefaultLoginPageGeneratingFi
lter.doFilter (DefaultlLoginPageGeneratingFilter. java:162)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.authentication.AbstractAuthenticationProcessin
gFilter.doFilter (AbstractAuthenticationProcessingFilter. java:205)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.authentication.logout.LogoutFilter.doFilter (Lo
goutFilter.java:120)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.header.HeaderWriterFilter.doFilterInternal (Hea
derWriterFilter. java:64)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilt
er.java:107)

04/20/2024 4/6




at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy. java:330)

at org.springframework.security.web.context.request.async.WebAsyncManagerIntegrati
onFilter.doFilterInternal (WebAsyncManagerIntegrationFilter. java:53)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilt
er.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.context.SecurityContextPersistenceFilter.doFil
ter (SecurityContextPersistenceFilter. java:91)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.FilterChainProxy.doFilterInternal (FilterChainP
roxy.Jjava:213)

at org.springframework.security.web.FilterChainProxy.doFilter (FilterChainProxy. jav
a:1706)

at org.springframework.web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingF
ilterProxy.java:346)

at org.springframework.web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterP
roxy.java:262)

at org.eclipse.jetty.servlet.ServletHandler$SCachedChain.doFilter (ServletHandler. ja
va:1652)

at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal (Charact
erEncodingFilter. java:121)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilt
er.java:107)

at org.eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. ja

va:1652)

at org.eclipse.jetty.servlet.ServletHandler.doHandle (ServletHandler. java:585)

at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:143)

at org.eclipse.jetty.security.SecurityHandler.handle (SecurityHandler. java:577)

at org.eclipse.jetty.server.session.SessionHandler.doHandle (SessionHandler. java:22
3)

at org.eclipse.jetty.server.handler.ContextHandler.doHandle (ContextHandler. java:11
27)

at org.eclipse.jetty.servlet.ServletHandler.doScope (ServletHandler.java:515)

at org.eclipse.jetty.server.session.SessionHandler.doScope (SessionHandler.java:185
)

at org.eclipse.jetty.server.handler.ContextHandler.doScope (ContextHandler.java:106
1)

at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:141)

at org.eclipse.jetty.server.handler.ContextHandlerCollection.handle (ContextHandler
Collection.java:215)

at org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper.java:97)

at org.eclipse.jetty.server.Server.handle (Server. java:497)

at org.eclipse.jetty.server.HttpChannel.handle (HttpChannel. java:310)

at org.eclipse.jetty.server.HttpConnection.onFillable (HttpConnection. java:257)

at org.eclipse. jetty.io.AbstractConnection$2.run (AbstractConnection. java:540)

at org.eclipse.jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635

at org.eclipse.jetty.util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)

at java.lang.Thread.run (Thread. java:745)

at org.springframework.remoting.support.RemoteInvocationUtils.fillInClientStackTra
celfPossible (RemoteInvocationUtils. java:45)

at org.springframework.remoting.support.RemoteInvocationResult.recreate (RemotelInvo
cationResult.java:149)

at org.springframework.remoting.support.RemoteInvocationBasedAccessor.recreateRemo
teInvocationResult (RemoteInvocationBasedAccessor. java:85)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (Ht
tpInvokerClientInterceptor.java:150)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.
java:208)

at com.sun.proxy.S$Proxy7.initializeCollection (Unknown Source)

at eu.etaxonomy.taxeditor.service.CachedCommonServiceImpl.initializeCollection (Cac
hedCommonServiceImpl. java:70)
at org.hibernate.collection.internal.AbstractPersistentCollection.remoteInitialize
(AbstractPersistentCollection. java:1340)
96 more

History

#1 - 09/12/2016 09:50 AM - Andreas Mdller

The relevant code is at CdmGenericDaolmpl.initializeCollection(UUID ownerUuid, ...) line 784

CdmBase cdmBase = load(ownerUuid, propertyPaths);
Field field = ReflectionUtils.findField(cdmBase.getClass (), fieldName) ;

So it looks like owerUuid does not exists anymore. Maybe it was deleted before by one of the many sessions Henning had opened? From the
stackstrace we can't say which uuid does not exist anymore.

So we could do the following:

Adjust the code in a way that the NPE is handled as a specific exception clearly explaining to the users that there is a required object that probably
has been deleted in the meanwhile and therefore the required action can not be performed.

On cdmlib side this exception handling needs to be generic. More difficult is the editor side where this problem may occur at many different places
and the question is if we want to catch and react on it always specifically.

Generally it is a concurrent transaction handling issue and which is a general issue that is not yet discussed and implemented properly.

#2 - 09/12/2016 09:50 AM - Andreas Miiller

- Assignee changed from Andreas Muiller to Katja Luther
#3 - 09/12/2016 10:04 AM - Andreas Kohlbecker
Henning was about to close some views/editors when this happened.

| think that this exception related to the fresh import that | applied to the running cdm instance while Henning had Editors with old data open.
This is a very unusual situation and | don#t think that we need to invest time for that, therefore i suggest to close this ticket as 'wontfix'.

#4 - 09/12/2016 10:18 AM - Andreas Miiller
So it is you who deleted data in the meanwhile?

However, the general transaction problem exist. No matter if an object is deleted by a fresh import or by some other user or by the same user within
an other transaction and it may reappear.

So at least improving the error handling for uuids which do not have a persisted object anymore to me seems like a good idea (also at other places).
Same as creating a new ticket for general transaction handling.
#5 - 09/12/2016 10:29 AM - Andreas Kohlbecker
Andreas Muller wrote:
So it is you who deleted data in the meanwhile?

Exaclty, the old data was deleted when applied the new import the db.
